function area = computeFacetAreaHrep(hrep, dirMatrix, zerotol)
% surface area or facet area of a H-polytope
%
% Syntax: area = computeFacetAreaVrep(hrep, dirMatrix)
%   or    area = computeFacetAreaVrep(hrep)
%
% The first variant calculates a vector of facet areas for all directions
%   in dirMatrix that contains one direction in each row. The second
%   variant calculates the surface area of the polytope. You might use
%   dirMatrix = [] to obtain the same behavior.
%
% computeFacetAreaHrep(..., zerotol) allows to set the tolerance for 
%   underlying algorithms (determining flat polytopes; default in
%   elkZerotol).
%
% See also: computeFacetAreaVrep, computeVolumeHrep,
%   computeProjectionAreaHrep, computeFeretHrep, computeSupportValueHrep

% The elk-library: convex geometry applied to crystallization modeling.
%   Copyright (C) 2012 Alexander Reinhold
%
% This program is free software: you can redistribute it and/or modify it 
%   under the terms of the GNU General Public License as published by the 
%   Free Software Foundation, either version 3 of the License, or (at your 
%   option) any later version.
%
% This program is distributed in the hope that it will be useful, but 
%   WITHOUT ANY WARRANTY; without even the implied warranty of 
%   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU 
%   General Public License for more details.
%
% You should have received a copy of the GNU General Public License along 
%   with this program.  If not, see <http://www.gnu.org/licenses/>.

%% Input handling
% default zerotol
if ~exist('zerotol', 'var')
    zerotol = elkZerotol;
end

%% Handle surface calculation (no dir given)
if ~exist('dirMatrix','var') || isempty(dirMatrix)
    dirMatrix = hrep.A;
    sumUp = 1;
else
    sumUp = 0;
end

%% Calculating area
% fall back to computeFacetAreaVrep
vrep = convertHrepToVrep(hrep, zerotol);
if ~isempty(vrep.V)
    area = computeFacetAreaVrep(vrep, dirMatrix, zerotol);
else
    area = 0;
end

if sumUp
    area = sum(area);
end